"use strict";
var fs = require("fs");
exports.introspectionFromFile = function (file) {
    return new Promise(function (resolve, reject) {
        if (fs.existsSync(file)) {
            try {
                var fileContent = fs.readFileSync(file, 'utf8');
                if (!fileContent) {
                    reject("Unable to read local introspection file: " + file);
                }
                resolve(JSON.parse(fileContent));
            }
            catch (e) {
                reject(e);
            }
        }
        else {
            reject("Unable to locate local introspection file: " + file);
        }
    });
};
//# sourceMappingURL=introspection-from-file.js.map